import "Turbine.UI";
import "Turbine.Gameplay"; -- this will expose the label control that we will implement
import "Turbine.UI.Lotro"; -- this will expose the standard window that we will implement

print=Turbine.Shell.WriteLine
--0x410d7ab7
--0x4101e50c
defaultData={}

-----------------------------------------------------------
local chatValues={["1"]=28,["2"]=29,["3"]=30,["4"]=31,["5"]=39,["6"]=40,["7"]=41,["8"]=42}

 -- define the AddCallback function
 function AddCallback(object, event, callback)
   if (object[event] == nil) then
     object[event] = callback;
   else
     if (type(object[event]) == "table") then
       table.insert(object[event], callback);
     else
       object[event] = {object[event], callback};
     end
   end
   return callback;
 end


 ChatMonitor = Turbine.Chat;
 ChatReceived = function(f, args)
  local msg = args.Message;
	
	if(args.ChatType == chatValues[data["Channel"]]) then
		if true then
			msg=string.gsub(msg,".+<Select.+<\\Select>:%s","")
			--msg=string.gsub(msg,"<>","")
			--print(msg)
			msg=decode(msg)
			for i=1,#msg do
				if msg[i]["Type"]=="Basic" and msg[i]["Version"] == version then
					if data["Other"][msg[i]["Date"]] == nil then
						data["Other"][msg[i]["Date"]]={}
					end
					data["Other"][msg[i]["Date"]][msg[i]["Replace"]]=nil
					data["Other"][msg[i]["Date"]][msg[i]["ID"]]=msg[i]
					if data["Recents"][string.gsub(msg[i]["ID"],"^%d+","")] == nil then
						data["Recents"][string.gsub(msg[i]["ID"],"^%d+","")]="0"
					end
					--print(tonumber(data["Recents"][string.gsub(msg[i]["ID"],"^%d+","")]))
					--print(string.match(msg[i]["ID"],"^(%d+)"))
					--Turbine.PluginData.Save(Turbine.DataScope.Character, "KinCalendarTesting", string.find(msg[i]["ID"],"^(%d+)"));
					if tonumber(data["Recents"][string.gsub(msg[i]["ID"],"^%d+","")]) < tonumber(string.match(msg[i]["ID"],"^(%d+)")) then
						data["Recents"][string.gsub(msg[i]["ID"],"^%d+","")]=string.match(msg[i]["ID"],"^(%d+)")
					end

				end
				if msg[i]["Type"]=="BasicRequest" and msg[i]["Version"] == version then
					local ids=msg[i]["IDs"]
					local needsSend = false
					local count=0
					for i in string.gmatch(ids,"%/([^%/]+)%/") do
						count=count+1
						--print(i)	
						if data["Recents"][string.gsub(i,"^%d+","")] == nil then
							data["Recents"][string.gsub(i,"^%d+","")]="0"
						end
						--Turbine.PluginData.Save(Turbine.DataScope.Character, "KinCalendarTesting", string.find(msg[i]["ID"],"^(%d+)"));
						if tonumber(data["Recents"][string.gsub(i,"^%d+","")]) > tonumber(string.match(i,"^(%d+)"))	 then
							needsSend=true
						end

					end
					local countTwo = 0
					for i in pairs(data["Recents"]) do
						countTwo=countTwo+1
					end
					--print(countTwo)
					--print(count)
					if needsSend == true or countTwo > count-1 then
						shareBasicData()
					end

					
				end
				--print(msg[i]["Version"])
			end
			Turbine.PluginData.Save(Turbine.DataScope.Character, "KinCalendar", data);
			updateCalendar()

		end
	end
 end



 AddCallback(Turbine.Chat, "Received", ChatReceived)
